/******************************************
	 Schlurp - Joueur virtuel
	 Pour Schlurp version 2 - Win32
	 (c) Pascal Peyremorte 1999

	 (c) <votre nom>

******************************************/


/******************************************
	Squelette en C driv de la version
	Delphi par Yanos El Guerilleros

	Tout les commentaires commencant par
	/*--
	sont de moi et font partie des
	remarques personnelles que j'ai mises
	pour la version C.

	Ce n'est qu'une base, que j'ai compile
	sans problme avec Borland C++ 5.02.
	Certaines particularits (comme
	__export et __stdcall) sont
	certainement  adapter a votre
	compilateur.
******************************************/

/*15/06/99  V1.00    Premire construction */

/*--  23/06/99 Adaptation en C++ sous BorlandC++ 5.02 */

/*-----------------------------------------------------------------------------
  Dclarations -  ne pas modifier -
-----------------------------------------------------------------------------*/

/* Taille du tableau */
#define  CaseMax 6 			/* Damier de 7x7	*/

/* Valeurs associes au contenu des cases du plateau */
#define VIDE (byte)0			/* Case vide */
#define J1   (byte)1;		/* Case occupe par le joueur 1 */
#define J2   (byte)2;		/* Case occupe par le joueur 2 */

/*-- Dfinition de type compatible Delphi */
typedef unsigned char byte;	/*-- Type byte est un octet non sign */

typedef struct{					/*-- pour le ShortString j'ai cr une structure */
	byte Size;						/*-- par fainantise pour la suite */
	char Text[255];
	}ShortString;

/* Contenu du plateau, indice X puis Y : Damier[Colonne][Ligne] */
typedef  byte TDamier[CaseMax+1][CaseMax+1];
typedef struct{
	byte XD, YD;		/* Case de dpart */
	byte XA, YA;		/* Case d'arrive */
  }TCoup;


/*-----------------------------------------------------------------------------
	Identification joueur, version et plateau
**---------------------------------------------------------------------------*/

/*-- Bon j'inclus strings.h pour la copie de nom */
#ifndef __STRING_H_
#include <string.h>
#endif

/*Cette procdure doit retourner votre identification.
 C'est le nom qui apparatra dans les menus 'Joueurs' de Schlurp
 par exemple 'Pascal P. V1.0' pour mon module initial */

extern "C" ShortString  __export __stdcall GetPlayerName()
{
	ShortString Result;
	/*-- Copie du nom */
	strcpy(Result.Text,"Yaya Test");
	/*-- Calcul de la taille du nom */
	Result.Size=(byte)strlen(Result.Text);
	/*-- retourne le rsultat */
	return Result;
}

/* Cette fonction n'est actuellement utilise que pour contrle.
 Elle pourra devenir intressante si le programme principal est modifi
 pour supporter plusieurs tailles de plateau, afin d'optimiser les algorithmes
 relativement  une taille donnes.
 Actuellement une dll ne rpondant pas 7 est ignore */

extern"C" int __export __stdcall GetBoardSize()
{
	return CaseMax+1;
}


/*-----------------------------------------------------------------------------
	Evaluation d'un coup (fumant...)
-----------------------------------------------------------------------------*/

/*Cette fonction retourne les coordonnes de dpart et d'arrive du pion  jouer.
 Elle n'est appele que si un coup au moins est jouable.

 Elle reoit en paramtre l'tat actuel du plateau dans Damier[X,Y] et
 le numro du joueur pour qui il faut rflchir...

 Dans Damier, chaque case contient la valeur
	 - <Vide> (=0) si elle est ... vide,
	 - <J1>   (=1) si elle est occupe par un pion du joueur 1
	 - <J2>   (=2) si elle est occupe par un pion du joueur 2

 Joueur vaut <J1> ou <J2>*/

extern"C" TCoup __export __stdcall ComputeMove(TDamier Damier,byte Joueur)
{
	char i,j;

	/*-- Ici je cr le coup que je vais calculer */
	TCoup MonCoup;

	/*--	Pour tester la DLL je me contente de chercher
			le premier dplacement d'une case que je
			peux faire
			ATTENTION, il sera considr comme tricheur
			si il le dernier coup qu'il peut faire se
			rvle tre un dplacement de deux cases
			C'EST JUSTE POUR TESTER :))) */

	for(i=0;i<CaseMax;i++)
		for(j=0;j<CaseMax;j++)
			if(Damier[i][j]==Joueur)
			{
				/*-- J'ai peut-tre trouv */
				MonCoup.XD=i;	MonCoup.YD=j;

				/*-- Je cherche la premire case vide autour */
				if(j>1 && Damier[i][j-1]==VIDE)
				{MonCoup.XA=i  ; MonCoup.YA=j-1; return MonCoup;};
				if(j<CaseMax-1 && Damier[i][j+1]==VIDE)
				{MonCoup.XA=i  ; MonCoup.YA=j+1; return MonCoup;};
				if (i>1) {
					if(j>1 && Damier[i-1][j-1]==VIDE)
					{MonCoup.XA=i-1; MonCoup.YA=j-1; return MonCoup;};
					if(Damier[i-1][j]==VIDE)
					{MonCoup.XA=i-1; MonCoup.YA=j  ; return MonCoup;};
					if(j<CaseMax-1 && Damier[i-1][j+1]==VIDE)
					{MonCoup.XA=i-1; MonCoup.YA=j+1; return MonCoup;};
				}
				if (i<CaseMax-1) {
					if(j>1 && Damier[i+1][j-1]==VIDE)
					{MonCoup.XA=i+1; MonCoup.YA=j-1; return MonCoup;};
					if(Damier[i+1][j]==VIDE)
					{MonCoup.XA=i+1; MonCoup.YA=j  ; return MonCoup;};
					if(j<CaseMax-1 && Damier[i+1][j+1]==VIDE)
					{MonCoup.XA=i+1; MonCoup.YA=j+1; return MonCoup;};
				}
			}
}


/*--
N'ayant pas eu envie de faire un fichier de dfinition
de module, je laisse ici la correspondance ordinale des
fonctions exportes (en Delphi, mais bon je crois que
ca se comprend facilement ;)

Exports
  GetNomJoueur     index 1 name 'GetPlayerName',
  GetTaillePlateau index 2 name 'GetBoardSize'),
  CalculeCoup      index 3 name 'ComputeMove';
end.

--*/

